% this script shows the dependency of average training set error (red) and test 
% set error (blue) on the training set size
%k_max is the maximum number of cosines (i.e. basis functions) that are
%used for regression

x_train = 3*rand(100,1);
x_test = 3*rand(100,1);

coeff_true = [4 3 2 1]';

y_test = generate_y(x_test, coeff_true, 5);
y_train = generate_y(x_train, coeff_true, 5);

k_max = 30;
error_train = zeros(k_max, 1);
error_test = zeros(k_max, 1);
for k=1:k_max
  F_train = generate_F(x_train, k);
  coeff = regress(F_train, y_train);
  error_train(k) = avg_error(x_train, y_train, coeff);
  error_test(k) = avg_error(x_test, y_test, coeff);
end;

plot(1:size(error_train,1), error_train, '-', 'LineWidth',2, 'Color', 'r');
hold on
plot(1:size(error_train,1), error_test, '-', 'LineWidth',2, 'Color', 'b');